package com.qf.dto;

import com.baomidou.mybatisplus.annotation.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.Date;

@Data
@AllArgsConstructor
@NoArgsConstructor

public class OwnerDto  {

    private Integer id;
    @NotNull(message = "【房屋id】不能为空")
    private Integer houseId;
    @NotNull(message = "【业主姓名不能为空】")
    private String ownName;
    //业主电话
    @NotNull(message="参数输入有误")
    @Pattern(regexp = "^1([358][0-9]|4[579]|66|7[0135678]|9[89])[0-9]{8}$",message = "【电话号输入有误】")
    private String ownPhone;
    //车牌号
    @NotNull(message="参数输入有误")
    @Pattern(regexp = "^[京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼使领A-Z]{1}[A-Z]{1}[A-Z0-9]{4}[A-Z0-9挂学警港澳]{1}$",message = "【车牌号输入有误")
    private String carNum;
    //车位id
    private Integer parkId;

}
